Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision b274bec8f4d5998686d5288eb4699d6281851f3f)
+++ sasmodels/models/core_multi_shell.py	(revision 6f0e04f2e9c3edcab46c213c3beb42345adc9aa5)
@@ -89,7 +89,7 @@
 parameters = [["volfraction", "", 0.05, [0,1],"",
                "volume fraction of spheres"],
-              ["sld", "1e-6/Ang^2", 1.0, [-inf, inf], "",
+              ["sld_core", "1e-6/Ang^2", 1.0, [-inf, inf], "",
                "Core scattering length density"],
-              ["radius", "Ang", 200., [0, inf], "",
+              ["radius", "Ang", 200., [0, inf], "volume",
                "Radius of the core"],
               ["sld_solvent", "1e-6/Ang^2", 6.4, [-inf, inf], "",
@@ -97,7 +97,7 @@
               ["n", "", 1, [0, 10], "volume",
                "number of shells"],
-              ["sld_shell[n]", "1e-6/Ang^2", 1.7, [-inf, inf], "",
+              ["sld[n]", "1e-6/Ang^2", 1.7, [-inf, inf], "",
                "scattering length density of shell k"],
-              ["thick_shell[n]", "Ang", 40., [0, inf], "volume",
+              ["thickness[n]", "Ang", 40., [0, inf], "volume",
                "Thickness of shell k"],
               ]
@@ -112,5 +112,5 @@
 
 
-def shape(core_sld, core_radius, solvent_sld, n, in_sld, out_sld, thickness, A):
+def profile(volfraction, sld_core, radius, sld_solvent, n, sld, thickness):
     """
     SLD profile
@@ -153,6 +153,5 @@
 # cut an the onion.  Seems like we should be consistant?
 
-    total_radius = 1.25*(sum(thickness[:n]) + core_radius + 1)
-    dr = total_radius/400  # 400 points for a smooth plot
+    total_radius = 1.25*(sum(thickness[:n]) + radius + 1)
 
     r = []
@@ -170,36 +169,21 @@
         r0 = r[-1]
         r.append(r0)
-        beta.append(sld_shell[k])
+        beta.append(sld[k])
         r.append(r0 + thickness[k])
-        beta.append(sld_shell[k])
+        beta.append(sld[k])
    # add in the solvent
     r.append(r[-1])
-    beta.append(solvent_sld)
+    beta.append(sld_solvent)
     r.append(total_radius)
-    beta.append(solvent_sld)
+    beta.append(sld_solvent)
 
     return np.asarray(r), np.asarray(beta)
 
-def ER(radius, n, thick_shell):
-    return np.sum(thick_shell[:n], axis=0) + core_radius
+def ER(radius, n, thickness):
+    n = n[0]  # n cannot be polydisperse
+    return np.sum(thickness[:n], axis=0) + radius
 
 def VR(radius, n, thick_shell):
-    return 1.0
-
-parameters = [["volfraction", "", 0.05, [0,1],"",
-               "volume fraction of spheres"],
-              ["sld", "1e-6/Ang^2", 1.0, [-inf, inf], "",
-               "Core scattering length density"],
-              ["radius", "Ang", 200., [0, inf], "",
-               "Radius of the core"],
-              ["sld_solvent", "1e-6/Ang^2", 6.4, [-inf, inf], "",
-               "Solvent scattering length density"],
-              ["n", "", 1, [0, 10], "volume",
-               "number of shells"],
-              ["sld_shell[n]", "1e-6/Ang^2", 1.7, [-inf, inf], "",
-               "scattering length density of shell k"],
-              ["thick_shell[n]", "Ang", 40., [0, inf], "volume",
-               "Thickness of shell k"],
-               ]
+    return 1.0, 1.0
 
 demo = dict(volfraction = 1.0,
Index: sasmodels/models/spherical_sld.py
===================================================================
--- sasmodels/models/spherical_sld.py	(revision e42b0b97594cafef1369a17613a32c7f8885d6ec)
+++ sasmodels/models/spherical_sld.py	(revision 6f0e04f2e9c3edcab46c213c3beb42345adc9aa5)
@@ -171,14 +171,13 @@
 #            ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [["n_shells",         "",               1,      [0, 9],         "", "number of shells"],
-              ["thick_inter[n]",   "Ang",            50,     [-inf, inf],    "", "intern layer thickness"],
+              ["radius_core",      "Ang",            50.0,   [0, inf],       "", "intern layer thickness"],
+              ["sld_core",         "1e-6/Ang^2",     2.07,   [-inf, inf],    "", "sld function flat"],
+              ["sld_flat[n]",      "1e-6/Ang^2",     4.06,   [-inf, inf],    "", "sld function flat"],
+              ["thick_flat[n]",    "Ang",            100.0,  [0, inf],       "", "flat layer_thickness"],
               ["func_inter[n]",    "",               0,      [0, 4],         "", "Erf:0, RPower:1, LPower:2, RExp:3, LExp:4"],
-              ["sld_core",         "1e-6/Ang^2",     2.07,   [-inf, inf],    "", "sld function flat"],
-              ["sld_solvent",      "1e-6/Ang^2",     1.0,    [-inf, inf],    "", "sld function solvent"],
-              ["sld_flat[n]",      "1e-6/Ang^2",     4.06,   [-inf, inf],    "", "sld function flat"],
-              ["thick_inter[n]",   "Ang",            50.0,   [0, inf],    "", "intern layer thickness"],
-              ["thick_flat[n]",    "Ang",            100.0,  [0, inf],    "", "flat layer_thickness"],
+              ["thick_inter[n]",   "Ang",            50.0,   [0, inf],       "", "intern layer thickness"],
               ["inter_nu[n]",      "",               2.5,    [-inf, inf],    "", "steepness parameter"],
               ["npts_inter",       "",               35,     [0, 35],        "", "number of points in each sublayer Must be odd number"],
-              ["core_rad",         "Ang",            50.0,   [0, inf],    "", "intern layer thickness"],
+              ["sld_solvent",      "1e-6/Ang^2",     1.0,    [-inf, inf],    "", "sld function solvent"],
               ]
 # pylint: enable=bad-whitespace, line-too-long
@@ -193,128 +192,26 @@
 
 demo = dict(
-        n_shells=4,
-        scale=1.0,
-        solvent_sld=1.0,
-        background=0.0,
-        npts_inter=35.0,
-        func_inter_0=0,
-        nu_inter_0=2.5,
-        rad_core_0=50.0,
-        core0_sld=2.07,
-        thick_inter_0=50.0,
-        func_inter_1=0,
-        nu_inter_1=2.5,
-        thick_inter_1=50.0,
-        flat1_sld=4.0,
-        thick_flat_1=100.0,
-        func_inter_2=0,
-        nu_inter_2=2.5,
-        thick_inter_2=50.0,
-        flat2_sld=3.5,
-        thick_flat_2=100.0,
-        func_inter_3=0,
-        nu_inter_3=2.5,
-        thick_inter_3=50.0,
-        flat3_sld=4.0,
-        thick_flat_3=100.0,
-        func_inter_4=0,
-        nu_inter_4=2.5,
-        thick_inter_4=50.0,
-        flat4_sld=3.5,
-        thick_flat_4=100.0,
-        func_inter_5=0,
-        nu_inter_5=2.5,
-        thick_inter_5=50.0,
-        flat5_sld=4.0,
-        thick_flat_5=100.0,
-        func_inter_6=0,
-        nu_inter_6=2.5,
-        thick_inter_6=50.0,
-        flat6_sld=3.5,
-        thick_flat_6=100.0,
-        func_inter_7=0,
-        nu_inter_7=2.5,
-        thick_inter_7=50.0,
-        flat7_sld=4.0,
-        thick_flat_7=100.0,
-        func_inter_8=0,
-        nu_inter_8=2.5,
-        thick_inter_8=50.0,
-        flat8_sld=3.5,
-        thick_flat_8=100.0,
-        func_inter_9=0,
-        nu_inter_9=2.5,
-        thick_inter_9=50.0,
-        flat9_sld=4.0,
-        thick_flat_9=100.0,
-        func_inter_10=0,
-        nu_inter_10=2.5,
-        thick_inter_10=50.0,
-        flat10_sld=3.5,
-        thick_flat_10=100.0
-        )
+    n_shells=4,
+    scale=1.0,
+    solvent_sld=1.0,
+    background=0.0,
+    npts_inter=35.0,
+    )
 
 oldname = "SphereSLDModel"
 oldpars = dict(
-        n_shells="n_shells",
-        scale="scale",
-        npts_inter='npts_inter',
-        solvent_sld='sld_solv',
-        func_inter_0='func_inter0',
-        nu_inter_0='nu_inter0',
-        background='background',
-        rad_core_0='rad_core0',
-        core0_sld='sld_core0',
-        thick_inter_0='thick_inter0',
-        func_inter_1='func_inter1',
-        nu_inter_1='nu_inter1',
-        thick_inter_1='thick_inter1',
-        flat1_sld='sld_flat1',
-        thick_flat_1='thick_flat1',
-        func_inter_2='func_inter2',
-        nu_inter_2='nu_inter2',
-        thick_inter_2='thick_inter2',
-        flat2_sld='sld_flat2',
-        thick_flat_2='thick_flat2',
-        func_inter_3='func_inter3',
-        nu_inter_3='nu_inter3',
-        thick_inter_3='thick_inter3',
-        flat3_sld='sld_flat3',
-        thick_flat_3='thick_flat3',
-        func_inter_4='func_inter4',
-        nu_inter_4='nu_inter4',
-        thick_inter_4='thick_inter4',
-        flat4_sld='sld_flat4',
-        thick_flat_4='thick_flat4',
-        func_inter_5='func_inter5',
-        nu_inter_5='nu_inter5',
-        thick_inter_5='thick_inter5',
-        flat5_sld='sld_flat5',
-        thick_flat_5='thick_flat5',
-        func_inter_6='func_inter6',
-        nu_inter_6='nu_inter6',
-        thick_inter_6='thick_inter6',
-        flat6_sld='sld_flat6',
-        thick_flat_6='thick_flat6',
-        func_inter_7='func_inter7',
-        nu_inter_7='nu_inter7',
-        thick_inter_7='thick_inter7',
-        flat7_sld='sld_flat7',
-        thick_flat_7='thick_flat7',
-        func_inter_8='func_inter8',
-        nu_inter_8='nu_inter8',
-        thick_inter_8='thick_inter8',
-        flat8_sld='sld_flat8',
-        thick_flat_8='thick_flat8',
-        func_inter_9='func_inter9',
-        nu_inter_9='nu_inter9',
-        thick_inter_9='thick_inter9',
-        flat9_sld='sld_flat9',
-        thick_flat_9='thick_flat9',
-        func_inter_10='func_inter10',
-        nu_inter_10='nu_inter10',
-        thick_inter_10='thick_inter10',
-        flat10_sld='sld_flat10',
-        thick_flat_10='thick_flat10')
+    #scale="scale",
+    #background='background',
+    #n_shells="n_shells",
+    radius_core='rad_core',
+    #sld_core='sld_core',
+    #sld_flat='sld_flat',
+    #thick_flat='thick_flat',
+    #func_inter='func_inter',
+    #thick_inter='thick_inter',
+    #inter_nu='nu_inter',
+    #npts_inter='npts_inter',
+    sld_solvent='sld_solv',
+    )
 
 #TODO: Not working yet
@@ -323,15 +220,15 @@
     [{'npts_iter':35,
         'sld_solv':1,
-        'func_inter_1':0.0,
-        'nu_inter':2.5,
-        'thick_inter_1':50,
-        'sld_flat_1':4,
-        'thick_flat_1':100,
-        'func_inter_0':0.0,
-        'nu_inter_0':2.5,
-        'rad_core_0':50.0,
-        'sld_core_0':2.07,
-        'thick_inter_0':50,
+        'radius_core':50.0,
+        'sld_core':2.07,
+        'func_inter2':0.0,
+        'thick_inter2':50,
+        'nu_inter2':2.5,
+        'sld_flat2':4,
+        'thick_flat2':100,
+        'func_inter1':0.0,
+        'thick_inter1':50,
+        'nu_inter1':2.5,
         'background': 0.0,
-    }, 0.001, 1000],
+    }, 0.001, 0.001],
 ]
